
import javafx.scene.CustomNode;
import javafx.scene.Group;
import javafx.scene.input.MouseEvent;
import javafx.scene.Node;
import javafx.scene.paint.Color;
import javafx.scene.paint.LinearGradient;
import javafx.scene.paint.Stop;
import javafx.scene.Scene;
import javafx.scene.shape.Line;
import javafx.scene.shape.Rectangle;
import javafx.scene.text.Text;

public class TitleBar extends CustomNode {

    public override function create(): Node {
        Group {
            content: [
                Rectangle {
                    x: 0,
                    y: 0
                    width: bind scene.width
                    height: 20
                    fill: LinearGradient {
                        startX: 0.0,
                        startY: 0.0,
                        endX: 1.0,
                        endY: 0.0
                        proportional: true
                        stops: [
                            Stop {
                                offset: 0.0
                                color: Color.GRAY
                            },
                            Stop {
                                offset: 1.0
                                color: Color.BLACK
                            }
                        ]
                    }
                    
                    // ^Cgo[hbOƃXe[Wړ
                    onMouseDragged: function(e:MouseEvent):Void {
                        scene.stage.x += e.dragX;
                        scene.stage.y += e.dragY;
                    }
                },
                // ^Cgo[ɃXe[W̃^Cg\
                Text {
                    x: 5
                    y: 15
                    fill: Color.WHITE
                    content: bind scene.stage.title;
                },
                // N[Y{^̊O̎lp
                Rectangle {
                    x: bind scene.width - 16
                    y: 4
                    width: 12
                    height: 12
                    fill: Color.BLACK
                    stroke: Color.WHITE
                    onMouseClicked: function( e: MouseEvent ):Void {
                        scene.stage.close();
                    }
                },
                // N[Y{^́~
                Line {
                    startX: bind scene.width - 16
                    startY: 4
                    endX: bind scene.width - 4
                    endY: 16
                    strokeWidth: 1
                    stroke: Color.WHITE
                },
                Line {
                    startX: bind scene.width - 4
                    startY: 4
                    endX: bind scene.width - 16
                    endY: 16
                    strokeWidth: 1
                    stroke: Color.WHITE
                },
            ]
        }
    }
}