
package whackamole;

import java.util.Random;
import javafx.animation.KeyFrame;
import javafx.animation.Timeline;
import javafx.fxd.FXDContent;
import javafx.fxd.FXDLoader;
import javafx.scene.input.MouseEvent;
import javafx.scene.Node;
import javafx.scene.Scene;
import javafx.stage.Stage;

var content: FXDContent
    = FXDLoader.loadContent("{__DIR__}resources/mole.fxz");
var base: Node = content.getNode("base");
var mole: Node = content.getNode("mole");
mole.opacity = 0;
var normal: Node = content.getNode("normal");
normal.opacity = 0;
var hit: Node = content.getNode("hit");
hit.opacity = 0;

var isHit = false;
var random = new Random();

mole.onMousePressed = function(event: MouseEvent): Void {
    if (mole.opacity == 1 and not isHit) {
        normal.opacity = 0;
        hit.opacity = 1;
        isHit = true;
    }
}

Timeline {
    repeatCount: Timeline.INDEFINITE
    keyFrames: [
        KeyFrame {
            time: 0ms
            action: function() {
                if (isHit) {
                    mole.opacity = 1;
                    normal.opacity = 0;
                    hit.opacity = 1;
                    isHit = false;
                } else {
                    hit.opacity = 0;
                    if (random.nextInt(4) mod 4 == 0) {
                        mole.opacity = 1;
                        normal.opacity = 1;
                    } else {
                        mole.opacity = 0;
                        normal.opacity = 0;
                    }
                }
            }
        },
        KeyFrame {
            time: 300ms
        },
    ]
}.play();

Stage {
    title: "Whack-A-Mole"
    scene: Scene {
        width: 240
        height: 240
        content: [ base, mole, normal, hit ]
    }
}